unit Graph;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, SciGraph;

type
  TForm1 = class(TForm)
    SciGraph1: TSciGraph;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Energy: TCheckBox;
    Log: TCheckBox;
    Label1: TLabel;
    procedure Open1Click(Sender: TObject);
    procedure EnergyClick(Sender: TObject);
    procedure LogClick(Sender: TObject);
    procedure SciGraph1Select(Sender: TObject);
  private
    { Private declarations }
  public
    XData, YData: array[1..1024] of Double;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.Open1Click(Sender: TObject);
var
	a,p: integer;
  fp: TStrings;
begin
	if OpenDialog1.Execute then begin
    fp:=TStringList.Create;
 		fp.LoadFromFile(OpenDialog1.FileName);
   	for a:=1 to 1024 do begin
 			p := Pos(' ',fp[a+4]);
   		YData[a]:=StrToFloat(Copy(fp[a+4],p,20));
 	  	XData[a]:=StrToFloat(Copy(fp[a+4],0,p));
   	end;
 		SciGraph1.Plot(YData);
 		SciGraph1.SetX(XData);
 		fp.Free;
  end;
end;

procedure TForm1.EnergyClick(Sender: TObject);
var
	a: Integer;
begin
	if Energy.Checked then
  	SciGraph1.XTitle := 'Energy (eV)'
  else
  	SciGraph1.XTitle := 'Wavelength ()';
  for a:=1 to 1024 do
  	if XData[a] > 0 then
	  	XData[a] := 12400/XData[a];
  SciGraph1.SetX(XData);
end;

function log10(X: Double): Double; far;
begin
	if X>0 then
		log10 := 0.43429*ln(X)
  else log10 := -1;
end;

function exp10(X: Double): Double; far;
begin
	exp10 := exp(2.30259*X);
end;

procedure TForm1.LogClick(Sender: TObject);
var
	a: Integer;
begin
	if Log.Checked then begin
		for a:=1 to 1024 do
  		YData[a] := log10(YData[a]);
  	SciGraph1.Plot(YData);
  	SciGraph1.SetX(XData);
  	SciGraph1.SuperScale(FALSE,NIL,NIL,TRUE,log10,exp10);
  end
  else begin
		for a:=1 to 1024 do
  		YData[a] := exp10(YData[a]);
  	SciGraph1.Plot(YData);
  	SciGraph1.SetX(XData);
  	SciGraph1.SuperScale(FALSE,NIL,NIL,FALSE,NIL,NIL);
  end;
end;

procedure TForm1.SciGraph1Select(Sender: TObject);
begin
	Label1.Caption := Format('Coordinates: [%4g, %4g]',[SciGraph1.X,SciGraph1.Y]);
end;

end.
